# Execute Vault Transaction

Executing a vault transaction will take all of the instructions saved in the `message` field of the corresponding Vault Transaction account, and atomically execute them via CPI. This requires that the Proposal accounts for the transaction is of `Approved` status, and the member running the instruction has `Executor` permissions.

## Example

```typescript
import * as multisig from "@sqds/multisig";
import { Connection, PublicKey } from "@solana/web3.js"

async function main(member: PublicKey) {
    // Cluster Connection
    const connection = new Connection("<your rpc url>");
    
    // If you've saved your createKey, you can define it as a static PublicKey
    const createKey = new PublicKey("<your createkey>")
    
    // Derive the multisig PDA
    const [multisigPda] = multisig.getMultisigPda({
        createKey,
    });
    // or
    // const multisigPda = new PublicKey("<your multisig key>");
    
    // Get deserialized multisig account info
    const multisigInfo = await multisig.accounts.Multisig.fromAccountAddress(
      connection,
      multisigPda
    );

    // Get the current transaction index
    const transactionIndex = Number(multisigInfo.transactionIndex);
    // or, if this is tied to your first transaction
    // const transactionIndex = 1n;
    
    const ix = await multisig.instructions.vaultTransactionExecute({
        multisigPda,
        transactionIndex,
        // Member must have "Executor" permissions
        member: member,
    });
}
```

### Notes

* Member must have "Executor" permissions
* Requires the corresponding proposal to be of `Approved` status
* Will execute each instruction via CPI, requiring the instructions to be valid
  * Since this is an asynchronous process, some instructions may become stale due to external program checks like slippage.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.squads.so/main/development/typescript/instructions/execute-vault-transaction.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
